//---------------------------------------------------------------------------
#ifndef FullPrevH
#define FullPrevH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ComCtrls.hpp>
#include <Dialogs.hpp>
#include <ExtCtrls.hpp>
#include <Menus.hpp>
#include <ToolWin.hpp>
//---------------------------------------------------------------------------
typedef void __fastcall (__closure *TOnDraw)(int X,int Y, Single Scale, Single FontScale, TCanvas *PrCanvas);
typedef void __fastcall (__closure *TRequestFullSize) (Single Scale, PSize Size);
typedef void __fastcall (__closure *TOnBeginPrint) (byte Pages);
typedef void __fastcall (__closure *TOnEndPrint) (byte Pages);
typedef void __fastcall (__closure *TOnPrintNextPage) (byte PageIndex);

class TPrScrollBox : public TScrollBox
{
private:
    void __fastcall WMHScroll(TWMHScroll& Msg);
    void __fastcall WMVScroll(TWMVScroll& Msg);
public:
    __fastcall TPrScrollBox(TComponent* Owner);
BEGIN_MESSAGE_MAP
  MESSAGE_HANDLER(WM_HSCROLL, TWMHScroll, WMHScroll);
  MESSAGE_HANDLER(WM_VSCROLL, TWMVScroll, WMVScroll);
END_MESSAGE_MAP(TScrollBox);
};

class PACKAGE TFullPreview : public TComponent
{
private:
    TOnDraw     FOnDraw;
    String      FPrintTitle;
    TRequestFullSize  FRequestFullSize;
    TOnBeginPrint     FOnBeginPrint;
    TOnPrintNextPage  FOnPrintNextPage;
    TOnEndPrint       FOnEndPrint;
protected:
public:
    byte        FPageCount;
    Single      FDeltaScale;
    __fastcall TFullPreview(TComponent* Owner);
    Boolean Execute();
__published:
    __property byte PageCount={read=FPageCount};
    __property String PrintTitle={read=FPrintTitle,write=FPrintTitle};
    __property TOnDraw OnDraw={read=FOnDraw,write=FOnDraw};
    __property TRequestFullSize RequestFullSize={read=FRequestFullSize,write=FRequestFullSize};
    __property TOnBeginPrint OnBeginPrint={read=FOnBeginPrint,write=FOnBeginPrint};
    __property TOnEndPrint OnEndPrint={read=FOnEndPrint,write=FOnEndPrint};
    __property TOnPrintNextPage OnPrintNextPage={read=FOnPrintNextPage,write=FOnPrintNextPage};
};

class TPreviewForm : public TForm
{
__published:	// IDE-managed Components
    TToolBar *ToolBar1;
    TToolButton *ToolButton1;
    TToolButton *ToolButton2;
    TToolButton *ToolButton3;
    TToolButton *ToolButton4;
    TToolButton *ToolButton5;
    TToolButton *ToolButton6;
    TPanel *Panel2;
    TLabel *Label1;
    TLabel *Label2;
    TLabel *Label3;
    TLabel *LPageCount;
    TComboBox *ComboBox1;
    TComboBox *ComboBox2;
    TButton *Button1;
    TStatusBar *StatusBar1;
    TPanel *VertPanel;
    TPanel *Panel5;
    TPanel *Panel6;
    TPanel *HorPanel;
    TImageList *ImageList1;
    TPopupMenu *PopupMenu1;
    TMenuItem *Printcurrentpage1;
    TMenuItem *PrintAllPages1;
    TPrintDialog *PrintDialog1;
    void __fastcall FormShow(TObject *Sender);

    void __fastcall ToolButton6Click(TObject *Sender);
    void __fastcall ComboBox1Change(TObject *Sender);
    void __fastcall Printcurrentpage1Click(TObject *Sender);
    void __fastcall PrintAllPages1Click(TObject *Sender);
    void __fastcall ComboBox2Change(TObject *Sender);
    void __fastcall ComboBox2KeyPress(TObject *Sender, char &Key);
    void __fastcall ComboBox1KeyPress(TObject *Sender, char &Key);
private:	   // User declarations
    void UpdateSize();
    void ChangeIScale(Single sc);
    void UpdateIScaleCombo();
    void RedrawPages(byte xp,byte yp);
    void DeletePage(byte pos,Boolean DirY);
    void __fastcall ScrollVert(TObject *Sender);
    void __fastcall ScrollHor(TObject *Sender);
public:		// User declarations
    void ChangePScale();
    void UpdatePScaleCombo();
    __fastcall TPreviewForm(TComponent* Owner);
    void __fastcall PageMouseDown(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
    void __fastcall PrPageClick(TObject *Sender);
    void __fastcall DrawPage(TCanvas *cc,byte xp,byte yp,Boolean ToPrinter);
    void __fastcall LineBarChange(TObject *Sender, WORD lBorder, WORD rBorder);
    Single  FScale;
    TPrScrollBox  *ScrollBox;
    TFullPreview  *ParentComponent;
    WORD FMaxWidth;
    WORD FMaxHeight;
};
//---------------------------------------------------------------------------
extern PACKAGE TPreviewForm *PreviewForm;
//---------------------------------------------------------------------------
#endif

